<?

// Tell the system we are in processor mode
$processor = 1;

// Set some initital variables
$processorVersion = "1.4";

// Includes
include "../conf.php";

// Load appropriate modules
recursiveModuleLoad();

// Simulate login to console
$login = new mySession("processor");

// Set Script TIMEOUT Value
set_time_limit(1000);

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

// Away we go!
processLoop();

function processLoop() {
	global $processorVersion;

	echo "\n";
        echo "----------------------------------------------------\n";
	echo ":: OpenAanval\n";
	echo ":: BPU: Background Processing Unit v$processorVersion\n";
	echo ":: IDS: OpenAanval " . versionText() . "\n";
	echo ":: Last processing finished " . statusProcessorLastRunDiff() . " seconds ago.\n";
	echo "----------------------------------------------------\n\n";

	remoteVersionCheck();
	remoteBulletinCheck();
	permissionsCheck();

	$objModule = new myModule();
	$objModule->loadModule("1");
	if ($objModule->getModuleVar("enabled") == 1) {
		idsTrackSnort();
	}

        $objModule = new myModule();
        $objModule->loadModule("2");
        if ($objModule->getModuleVar("enabled") == 1) {
                idsTrackSyslog();
        }

	pruneIdsTrack();

	// IP to Hostname Lookups
	hostnameLookup();

	// OAD
	$oadProcess = oadProcess();

	$objStatus = new myStatus();
	$objStatus->loadStatus();
	$objStatus->setStatusVar("processor_lastRun", date("U"));
        if ($oadProcess == 1) $objStatus->setStatusVar("oad_lastUpload", date("U"));
        if ($oadProcess == 1) $objStatus->totalOadUploadIncrement();

	$objStatus->totalProcessorRunIncrement();
        $objStatus->saveStatus();

        echo "\n";
        echo "----------------------------------------------------\n";
	echo ":: Complete\n";
        echo "----------------------------------------------------\n";
	echo "\n\n\n\n\n";

#	debugProcessor();

	exit;
}

function idsTrackSyslog() {
        global $root_path, $aanvaldbhost, $aanvaldbuser, $aanvaldbpass, $aanvaldb;

	$sensor_files = getSensorFiles();

        $objModule = new myModule();
        $objModule->loadModule("2");

	// identify and write new syslog devices to syslog.sensors table
	for ($i=0;$i<count($sensor_files);$i++) {
		$sourceIPa = str_replace("indata_", "", (str_replace(".syslog", "", $sensor_files[$i])));
#	        echo ".. Processing Sensor ::SYSLOG:: $sourceIPa ($sensor_files[$i])\n";
                $sourceIP = ip_to_acid($sourceIPa);

                $db = mysql_connect($objModule->getModuleVar("auth_db_host"), $objModule->getModuleVar("auth_db_user"), $objModule->getModuleVar("auth_db_pass")) or die("Could not connect");
                mysql_select_db($objModule->getModuleVar("auth_db")) or die("Error #99177018");
                $dquery = mysql_query("select sid from sensors where source = '$sourceIP'") or die(mysql_error());
                while (list($d_sid) = mysql_fetch_row($dquery)) {
                	$sid = $d_sid;
                       	$sensor_found = 1;
                }
                if (!$sensor_found) {
	                $dquery = mysql_query("insert into sensors (source) values ('$sourceIP')");
			echo ".. New Syslog Sensor Found ($sensorIPa)\n";
		}
                mysql_close($db);
	}

        $objSensor = new mySensor();
        $sensorIDs = $objSensor->getSensorIDs(2);

        for ($i=0;$i<count($sensorIDs);$i++) {
                echo ".. Processing Sensor: SYSLOG\t$sensorIDs[$i]";

		// Load Sensor
                $objSensor->loadSensor($sensorIDs[$i]);

                // Define Sensor Variables
                $sensorSID = $objSensor->getSensorVar("sid");


                $moduleDB = new moduleDB;
                $moduleDB->loadDB(2);
                $moduleQuery = $moduleDB->query("select f_sample, source, f_date, f_time, f_level, f_data, f_message, f_protocol,
						f_sip, f_dip from sensors where sid = $sensorSID");
		while (list($f_sample, $source, $f_date, $f_time, $f_level, $f_data, $f_message, $f_protocol, 
			$f_sip, $f_dip) = mysql_fetch_row($moduleQuery)) {

	                $sensorSource = acid_to_ip($source);
	                $sensorFilterDate = $f_date;
	                $sensorFilterTime = $f_time;
	                $sensorFilterLevel = $f_level;
			$sensorFilterData = $f_data;
                        $sensorFilterMessage = $f_message;
                        $sensorFilterProtocol = $f_protocol;
                        $sensorFilterSip = $f_sip;
                        $sensorFilterDip = $f_dip;

			if (file_exists("/$root_path/syslog/indata_$sensorSource.syslog")) {
				rename("/$root_path/syslog/indata_$sensorSource.syslog", "/$root_path/syslog/indata_$sensorSource.processing");
			}

                        if (file_exists("/$root_path/syslog/indata_$sensorSource.processing")) {
				$handle = @fopen("/$root_path/syslog/indata_$sensorSource.processing", "r");
				if ($handle) {
					while (!feof($handle)) {

			                        $timestamp = date("U");

						$buffer = fgets($handle, 4096);

						if ($buffer != "") {
							preg_match("/$f_time/", $buffer, $match);
							$time = trim(rtrim($match[0]));

        	                                        preg_match("/$f_date/", $buffer, $match);
	                                                $date = trim(rtrim($match[0]));

	                                                preg_match("/$f_level/", $buffer, $match);
	                                                $level = trim(rtrim($match[0]));

                                                        preg_match("/$f_data/", $buffer, $match);
                                                        $data = trim(rtrim($match[0]));

                                                        preg_match("/$f_message/", $buffer, $match);
                                                        $message = trim(rtrim($match[0]));

                                                        preg_match("/$f_protocol/", $buffer, $match);
                                                        $protocol = trim(rtrim($match[0]));

                                                        preg_match("/$f_sip/", $buffer, $match);
                                                        $sip = ip_to_acid(trim(rtrim($match[0])));

                                                        preg_match("/$f_dip/", $buffer, $match);
                                                        $dip = ip_to_acid(trim(rtrim($match[0])));

							if (!strstr(date("Y"), $date)) $date = $date . " " . date("Y");
							$intime = strtotime("$date $time");

							// IF !sip then set to source
							if (!$sip) $sip = $source;

							$moduleDBa = new moduleDB;
					                $moduleDBa->loadDB(2);
							$moduleQueryA = $moduleDBa->query("insert into data 
								(sip, dip, sport, dport, proto, level, data, message, epoch, timestamp) values
								('$sip', '$dip', '$sport', '$dport', '17', '$level', '$data', '$message', 
									'$intime', '$timestamp')");

                                                        $lastDataID = mysql_insert_id();

				                        $idsDB = new idsDB;
				                        $idsQueryA = $idsDB->query("insert into idsTrack (eid, enameid, sensorid, sid, epoch, etypeid, 
								etypename, ename, sip, dip,
				                                sport, dport, proto, module, timestamp, enabled, level, xcol1) values
			                                        ('$lastDataID', '$c_sig_sid', '$sensorIDs[$i]', '$sensorSID', '$intime', '$c_sig_class_id', 
								'$c_sig_class_name',
			                                        '$message', '$sip', '$dip', '$src_port', '$dport', '17', '2',
			                                        '$timestamp', 1, '$level', '0')");


				                        $lastTrackID = mysql_insert_id();

				                        $idsDB = new idsDB;
				                        $idsQueryA = $idsDB->query("insert into idsMain (id, eid, enameid, sensorid, sid, epoch, etypeid, 
								etypename, ename, sip, dip,
				                                sport, dport, proto, module, timestamp, enabled, level, xcol1) values
				                                ('$lastTrackID', '$lastDataID', '$c_sig_sid', '$sensorIDs[$i]', '$sensorSID', '$intime', 
								'$c_sig_class_id', '$c_sig_class_name',
				                                '$message', '$sip', '$dip', '$src_port', '$dport', '17', '2',
				                                '$timestamp', 1, '$c_sig_priority', '0')");

							// IF SAMPLE IS EMPTY - Fill it with buffer data
							if ($f_sample == "") {
								$moduleDBa = new moduleDB;
        	                                                $moduleDBa->loadDB(2);
	                                                        $moduleQueryA = $moduleDBa->query("update sensors set f_sample = '$buffer' 
									where sid = $sensorSID");
							}
						}

					}
					fclose($handle);
				}
				unlink("/$root_path/syslog/indata_$sensorSource.processing");
			}
		}


#                        $idsDB = new idsDB;
#                        $idsQueryA = $idsDB->query("insert into idsTrack (eid, enameid, sensorid, sid, epoch, etypeid, etypename, ename, sip, dip,
#                                sport, dport, proto,module, timestamp, enabled, level, xcol1) values
#                                        ('$c_id', '$c_sig_sid', '$id[$i]', '$c_sid', '$c_time', '$c_sig_class_id', '$c_sig_class_name',
#                                        '$c_sig_name', '$ip_source', '$ip_dest', '$src_port', '$dst_port', '$ip_proto', '1',
#                                        '$time', 1, '$c_sig_priority', '0')");
#
#                        $last_id = mysql_insert_id();
#
#                        $idsDB = new idsDB;
#                        $idsQueryA = $idsDB->query("insert into idsMain (id, eid, enameid, sensorid, sid, epoch, etypeid, etypename, ename, sip, dip,
#                                sport, dport, proto,module, timestamp, enabled, level, xcol1) values
#                                        ('$last_id', '$c_id', '$c_sig_sid', '$id[$i]', '$c_sid', '$c_time', '$c_sig_class_id', '$c_sig_class_name',
#                                        '$c_sig_name', '$ip_source', '$ip_dest', '$src_port', '$dst_port', '$ip_proto', '1',
#                                        '$time', 1, '$c_sig_priority', '0')");
#

		echo "\t.. Done\n";

	}
}

function getSensorFiles() {
        global $ops, $root_path;

        # Read in all available modules recursively
        if (!$this_dir = @dir("$root_path/" . $ops->getOpsVar("site_dir_syslog"))) {
                echo "conf.php ERROR:<p>\$root_path not correct or $root_path/syslog/ not found! Check your conf.php settings<p>Exiting.";
                exit;
        }

	while ($dir = $this_dir->read()) {
	        while ($file = $this_dir->read()) {
        	        if ($file != "." && $file != "..") {
                	        if (substr($file, -7, 7) == ".syslog") {
	                                $files_array[] = $file;
                                }
                        }
                }
        }

	return $files_array;
}

function idsTrackSnort() {
        global $aanvaldbhost, $aanvaldbuser, $aanvaldbpass, $aanvaldb;

	// Create Sensor Object
	$objSensor = new mySensor();

	// ARRAY Sensor ID's
	$id = $objSensor->getSensorIDs(1);

	// LOOP OVER EACH SENSOR ID
        for ($i=0;$i<count($id);$i++) {
		// Load Sensor
                $objSensor->loadSensor($id[$i]);

		// Define Sensor Variables
                $sensorSID = $objSensor->getSensorVar("sid");
                $sensorName = $objSensor->getSensorVar("name");

	        echo ".. Processing Sensor: SNORT\t$id[$i]";

                // GET LAST ID of Tracking Table
		$eidStart = getLastMainID($id[$i]);

		// GET DATA from SNORT tables and POPULATE tracking tables
		$moduleDB = new moduleDB;
		$moduleDB->loadDB(1);
                $moduleQuery = $moduleDB->query("SELECT event.cid, event.sid, event.signature, UNIX_TIMESTAMP(event.timestamp), signature.sig_sid, signature.sig_priority, signature.sig_name, signature.sig_class_id, iphdr.ip_src, iphdr.ip_dst, iphdr.ip_proto FROM event, signature, iphdr where event.cid > $eidStart and event.sid = $sensorSID and event.signature = signature.sig_id and event.cid = iphdr.cid and event.sid = iphdr.sid limit 10000");
                while (list($c_id, $c_sid, $sig_id, $c_time, $c_sig_sid, $c_sig_priority, $c_sig_name, $c_sig_class_id,
                        $ip_source, $ip_dest, $ip_proto) = mysql_fetch_row($moduleQuery)) {

			$time = date("U");

                        $moduleDB1 = new moduleDB;
                        $moduleDB1->loadDB(1);
                        $pquery = $moduleDB1->query("select sig_class.sig_class_name from sig_class where sig_class_id = $c_sig_class_id");
                        while (list($d_class_name) = mysql_fetch_row($pquery)) {
				$c_sig_class_name = $d_class_name;
                        }

                        if ($ip_proto == 6) {
		                $moduleDB1 = new moduleDB;
		                $moduleDB1->loadDB(1);
	                        $pquery = $moduleDB1->query("select tcp_sport, tcp_dport from tcphdr where cid = $c_id and sid = $c_sid");
                                while (list($x_src_port, $x_dst_port) = mysql_fetch_row($pquery)) {
        	                        $src_port = $x_src_port;
                                        $dst_port = $x_dst_port;
                                }
                        } else if ($ip_proto == 17) {
                                $moduleDB1 = new moduleDB;
                                $moduleDB1->loadDB(1);
                                $pquery = $moduleDB1->query("select udp_sport, udp_dport from udphdr where cid = $c_id and sid = $c_sid");
                                while (list($x_src_port, $x_dst_port) = mysql_fetch_row($pquery)) {
	                                $src_port = $x_src_port;
                                        $dst_port = $x_dst_port;
	                        }
                        }


	                $idsDB = new idsDB;
			$idsQueryA = $idsDB->query("insert into idsTrack (eid, enameid, sensorid, sid, epoch, etypeid, etypename, ename, sip, dip, 
				sport, dport, proto,module, timestamp, enabled, level, xcol1) values
                                        ('$c_id', '$c_sig_sid', '$id[$i]', '$c_sid', '$c_time', '$c_sig_class_id', '$c_sig_class_name',
                                        '$c_sig_name', '$ip_source', '$ip_dest', '$src_port', '$dst_port', '$ip_proto', '1',
                                        '$time', 1, '$c_sig_priority', '0')");

			$last_id = mysql_insert_id();

                        $idsDB = new idsDB;
                        $idsQueryA = $idsDB->query("insert into idsMain (id, eid, enameid, sensorid, sid, epoch, etypeid, etypename, ename, sip, dip,
                                sport, dport, proto,module, timestamp, enabled, level, xcol1) values
                                        ('$last_id', '$c_id', '$c_sig_sid', '$id[$i]', '$c_sid', '$c_time', '$c_sig_class_id', '$c_sig_class_name',
                                        '$c_sig_name', '$ip_source', '$ip_dest', '$src_port', '$dst_port', '$ip_proto', '1',
                                        '$time', 1, '$c_sig_priority', '0')");


			if ($cnt < 500) {
	                        frequentOffenders($ip_source);
			}
                        offenderAnalysisDatabase($ip_source, $c_sig_sid);

			actionProcess($last_id, 1, $c_sig_sid, $c_sig_class_id, $id[$i], $ip_source, $ip_dest, $src_port, $dst_port, $ip_proto, $c_sig_priority);

			$cnt++;

		}

                unset($eid_start);

		echo "\t.. Done\n";
	}

}

function pruneIdsTrack() {
        global $ops, $aanvaldbhost, $aanvaldbuser, $aanvaldbpass, $aanvaldb;

        $db = mysql_connect("$aanvaldbhost", "$aanvaldbuser", "$aanvaldbpass") or die("Could not connect");
        mysql_select_db($aanvaldb) or die("Error #9021632");

        $dquery = mysql_query("select count(*) from " . $ops->getOpsVar("site_table.idsTrack"));
        while (list($d_count) = mysql_fetch_row($dquery)) {
                $count = $d_count;
        }

	if ($count > $ops->getOpsVar("site_idstrack_max_rows")) {
		$total = $count - $ops->getOpsVar("site_idstrack_max_rows");
		mysql_query("delete from " . $ops->getOpsVar("site_table.idsTrack") . " where id > 1 limit $total");
	}
        mysql_close($db);
}

function hostnameLookup() {
        global $ops, $aanvaldb, $aanvaldbuser, $aanvaldbpass, $aanvaldbhost;

        echo ".. Hostname Lookups [";

        $db = mysql_connect("$aanvaldbhost", "$aanvaldbuser", "$aanvaldbpass");
        mysql_select_db("$aanvaldb");
        $dquery = mysql_query("select ip from " . $ops->getOpsVar("site_table.idsFrequentOffenders"));
        while (list($d_ip) = mysql_fetch_row($dquery)) {
                $list[] = $d_ip;
        }

        for ($i=0;$i<count($list);$i++) {

	        $epoch = date("U");
                unset($exists);

                $dquery = mysql_query("select ip, timestamp from " . $ops->getOpsVar("site_table.idsHostnames") . " where ip = $list[$i]");
                while (list($d_ip, $d_intime) = mysql_fetch_row($dquery)) {
                        $ip = $d_ip;
                        $exists = 1;
                }

                if (!$exists) {
	                echo ".";
                        $hostname = gethostbyaddr(acid_to_ip($list[$i]));
                        mysql_query("insert into " . $ops->getOpsVar("site_table.idsHostnames") . " (ip, hostname, timestamp) 
				values ('$list[$i]', '$hostname', '$epoch')");
			$cnt++;
                }

		if ($cnt > 30) break;
        }
        mysql_close($db);

	echo "]\n";
}

function frequentOffenders($ip) {
        global $ops, $aanvaldbhost, $aanvaldbuser, $aanvaldbpass, $aanvaldb;

	$epoch = date("U");
	$time_limit = $epoch - 259200;

        $db = mysql_connect("$aanvaldbhost", "$aanvaldbuser", "$aanvaldbpass") or die("Could not connect");
        mysql_select_db($aanvaldb) or die("Error #9088632");

        mysql_query("insert into " . $ops->getOpsVar("site_table.idsFrequentOffenders") . " (ip, cnt, timestamp) values ('$ip', '0', '$epoch')");
        $dquery = mysql_query("select cnt from " . $ops->getOpsVar("site_table.idsFrequentOffenders") . " where ip = $ip");
        while (list($d_count) = mysql_fetch_row($dquery)) {
	        $count = $d_count + 1;
        }

	mysql_query("update " . $ops->getOpsVar("site_table.idsFrequentOffenders") . " set cnt = $count, timestamp = $epoch where ip = $ip");
        mysql_query("delete from " . $ops->getOpsVar("site_table.idsFrequentOffenders") . " where timestamp < $time_limit");

	mysql_close($db);
}

function offenderAnalysisDatabase($ip, $event) {
        global $ops, $aanvaldbhost, $aanvaldbuser, $aanvaldbpass, $aanvaldb;

	$dotted = acid_to_ip($ip);
	$dot = explode(".", $dotted);	

	// OAD doesn't want private network data or loopback communications - It'll clog things up
	if ($dot[0] == 10) {
                $ops->setOpsVar("site_oadUpload", 0);
	} else if ($dot[0] == 127) {
                $ops->setOpsVar("site_oadUpload", 0);
	} else if ($dot[0] == 192 && $dot[1] == 168) {
                $ops->setOpsVar("site_oadUpload", 0);
	} else if ($dot[0] == 172 && $dot[1] == 16) {
                $ops->setOpsVar("site_oadUpload", 0);
        } else if ($dot[0] == 127 && $dot[1] == 255) {
                $ops->setOpsVar("site_oadUpload", 0);
	}

	if ($ops->getOpsVar("site_oadUpload") == 1) {

	        $epoch = date("U");

	        $db = mysql_connect("$aanvaldbhost", "$aanvaldbuser", "$aanvaldbpass") or die("Could not connect");
	        mysql_select_db($aanvaldb) or die("Error #9027642");
	        mysql_query("insert into " . $ops->getOpsVar("site_table.idsOadBuffer") . " (ip, sig_id, timestamp) values ('$ip', '$event', '$epoch')");
		mysql_close($db);
	}
}

function oadProcess() {
        global $ops, $aanvaldbhost, $aanvaldbuser, $aanvaldbpass, $aanvaldb;

        if ($ops->getOpsVar("site_oadUpload") == 1) {
	        $db = mysql_connect("$aanvaldbhost", "$aanvaldbuser", "$aanvaldbpass") or die("Could not connect");
	        mysql_select_db($aanvaldb) or die("Error #9083301");
	        $dquery = mysql_query("select count(*) from " . $ops->getOpsVar("site_table.idsOadBuffer"));
	        while (list($d_count) = mysql_fetch_row($dquery)) {
		        $count = $d_count;
	        }
	        mysql_close($db);

		if (statusOadLastUploadDiff() > $ops->getOpsVar("site_oadInterval") || $count > $ops->getOpsVar("site_oadBuffer")) {
			// send data to aanval.com
			transmitOAD();

			return 1;
		} else {
			return 0;
		}
	}
}

function transmitOAD() {
        global $ops, $aanvaldbhost, $aanvaldbuser, $aanvaldbpass, $aanvaldb;

	echo ".. Processing OAD: ";

        $db = mysql_connect("$aanvaldbhost", "$aanvaldbuser", "$aanvaldbpass") or die("Could not connect");
        mysql_select_db($aanvaldb) or die("Error #9083301");
        $dquery = mysql_query("select id, ip, sig_id, timestamp from " . $ops->getOpsVar("site_table.idsOadBuffer") . " order by 
		timestamp limit " . $ops->getOpsVar("site_oadBuffer"));
        while (list($d_id, $d_ip, $d_sig_id, $d_timestamp) = mysql_fetch_row($dquery)) {

		// build payload
		$payload .= "$d_ip:$d_sig_id:$d_timestamp||";

                // delete buffer data from table
                mysql_query("delete from " . $ops->getOpsVar("site_table.idsOadBuffer") . " where id = $d_id");
        }

        mysql_close($db);

	// base64 payload data
	$payload = base64_encode($payload);

        $read = @file("http://oad.aanval.com/oad_payload.php?payload=$payload&certify=$key1");
        $out = $read[0];

        echo "[Upload] ";

	if (rtrim($out) == 1) {
		echo "Success";
	} else {
		echo "Failure";
	}

	echo "\t.. Done\n";
}

function permissionsCheck() {
	global $root_path;

        if (!file_exists("$root_path/poll/tmp")) @mkdir("$root_path/poll/tmp");
        chmod("$root_path/poll/tmp", 0777);

        if (!file_exists("$root_path/poll/tmp")) @mkdir("$root_path/tmp");
        chmod("$root_path/tmp", 0777);

        if (!file_exists("$root_path/poll/tmp")) @mkdir("$root_path/version");
        chmod("$root_path/version", 0777);

}

function remoteVersionCheck() {
        global $version_checking, $root_path;

        if ($version_checking != 0) {

                $epoch = date("U");
                $tmp = @file ("$root_path/version/version.txt");
                $major = rtrim($tmp[0]);
                $minor = rtrim($tmp[1]);
                $name = rtrim($tmp[2]);

                $tmp = @file ("$root_path/version/ver");
                $time = rtrim($tmp[3]);

                if (($time + 1800) < $epoch) {

                        echo ".. Checking Aanval.com for Versions\n";

                        $read = @file("http://update.aanval.com/updater/openaanval_ver.php?major=$major&minor=$minor");
                        $out = rtrim($read[0]) . "\n" . rtrim($read[1]) . "\n" . rtrim($read[2]) . "\n" . "$epoch";

                        $fp = fopen ("$root_path/version/ver", "w");
                        if ($fp) {
                                fputs ($fp, "$out");
                                fclose($fp);
                        }
                }
        }
}

function remoteBulletinCheck() {
        global $bulletin_checking, $root_path;

        if ($bulletin_checking != 0 || $bulletin_checking != "no") {

		$epoch = date("U");
                $tmp = @file ("$root_path/bulletin/info");
                $time = $tmp[0];

                if (($time + 1800) < $epoch) {

		        echo ".. Checking Aanval.com for Bulletins\n";

                        $read = @file("http://update.aanval.com/bulletin/openaanval_info.php");

			$out = "$epoch\n";			
			for ($i=0;$i<count($read);$i++) {
				$out .= $read[$i];
			}

                        $fp = fopen ("$root_path/bulletin/info", "w");
                        if ($fp) {
                                fputs ($fp, "$out");
                                fclose($fp);
                        }
                }
        }
}

function recursiveModuleLoad() {
        global $root_path;

        # Read in all available modules recursively
        if (!$this_dir = @dir("$root_path/modules/")) {
                echo "conf.php ERROR:<p>\$root_path not correct or $root_path/modules/ not found! Check your conf.php settings<p>Exiting.";
                exit;
        }
        while ($dir = $this_dir->read()) {
                if ($dir != "." && $dir != "..") {
                        if (substr($dir, -4, 4) == "_MOD") {
                                $this_sub = dir("$root_path/modules/$dir");
                                while ($file = $this_sub->read()) {
                                        if ($file != "." && $file != "..") {
                                                if (substr($file, 0,4) == "inc_") {
                                                        include "../modules/$dir/$file";
                                                }
                                        }
                                }
                        }
                }
        }
}

function getLastMainID($id) {
        global $ops, $aanvaldbhost, $aanvaldbuser, $aanvaldbpass, $aanvaldb;

        $db = mysql_connect("$aanvaldbhost", "$aanvaldbuser", "$aanvaldbpass") or die("Could not connect");
        mysql_select_db($aanvaldb) or die("Error #9027632");
        $mysqlQueryA = mysql_query("select eid from idsMain where sensorid = $id order by eid desc limit 1");
        while ($row = mysql_fetch_row($mysqlQueryA)) {
	        $eidStart = $row[0];
        }

        mysql_free_result($mysqlQueryA);
        if (!$eidStart) $eidStart = 0;
        mysql_close($db);

	return $eidStart;
}

function actionProcess($trackid, $module, $enameid, $etypeid, $sensorid, $sip, $dip, $sport, $dport, $proto, $level) {

        $objAction = new myAction();
	$actions = $objAction->getActionIDs();

	for ($i=0;$i<count($actions);$i++) {

                $positive = 0;
                $objAction->actionLoad($actions[$i]);

		// if MATCH || EMPTY => POSITIVE

		// IP
		if ($objAction->getActionVar("sip") == $sip || $objAction->getActionVar("sip") == "4294967295") {
			$positive = 1;
		} else {
                        $positive = 0;
			continue;
		}
                if ($objAction->getActionVar("dip") == $dip || $objAction->getActionVar("dip") == "4294967295") {
                        $positive = 1;
                } else {
                        $positive = 0;
                        continue;
                }

		// PORT
                if ($objAction->getActionVar("sport") == $sport || $objAction->getActionVar("sport") == "0") {
                        $positive = 1;
                } else {
                        $positive = 0;
                        continue;
                }
                if ($objAction->getActionVar("dport") == $dport || $objAction->getActionVar("dport") == "0") {
                        $positive = 1;
                } else {
                        $positive = 0;
                        continue;
                }

                // ENAMEID
                if ($objAction->getActionVar("enameid") == $enameid || $objAction->getActionVar("enameid") == "0") {
                        $positive = 1;
                } else {
                        $positive = 0;
                        continue;
                }

                // ETYPEID
                if ($objAction->getActionVar("etypeid") == $etypeid || $objAction->getActionVar("etypeid") == "0") {
                        $positive = 1;
                } else {
                        $positive = 0;
                        continue;
                }

		// SENSOR
                if ($objAction->getActionVar("sensorid") == $sensorid || $objAction->getActionVar("sensorid") == "0") {
                        $positive = 1;
                } else {
                        $positive = 0;
                        continue;
                }

                // MODULE
                if ($objAction->getActionVar("module") == $module || $objAction->getActionVar("module") == "0") {
                        $positive = 1;
                } else {
                        $positive = 0;
                        continue;
                }

                // LEVEL
                if ($objAction->getActionVar("level") == $level || $objAction->getActionVar("level") == "0") {
                        $positive = 1;
                } else {
                        $positive = 0;
                        continue;
                }

                // PROTO
                if ($objAction->getActionVar("proto") == $proto || $objAction->getActionVar("proto") == "0") {
                        $positive = 1;
                } else {
                        $positive = 0;
                        continue;
                }

		if ($positive == 1) {
			actionMatch($actions[$i], $trackid);
		}
	}
}

function actionMatch($action, $trackid) {

        $objAction = new myAction();
	$objAction->actionLoad($action);
        $objAction->setThresholdEventTime();
	$objAction->incrementCount();
        $objAction->incrementThreshold();

	if ($objAction->getActionVar("threshold_count") >= $objAction->getActionVar("threshold")) {

	        $objAction->oneTimeCheck();

		if ($objAction->getActionVar("type") == 3) {
			actionEmail($action, $trackid, $objAction->getActionVar("xcol1"));
			echo "\n.. EMAIL: ($action $trackid) => " . $objAction->getActionVar("xcol1") . "\n";
		} else if ($objAction->getActionVar("type") == 4) {
			writeSemaphore($objAction->getActionVar("xcol4"));
                } else if ($objAction->getActionVar("type") == 5) {
                        execCommand($objAction->getActionVar("xcol5"));
                }


		if ($objAction->getActionVar("xcol2") != 0) {
			$objCollection = new myCollection;
			$objCollection->collectionListingAddA($objAction->getActionVar("xcol2"), $trackid, $objAction->getActionVar("userid"));
		}

		$idsDB = new idsDB;
                $idsQueryA = $idsDB->query("update idsTrack set xcol1 = " . $objAction->getActionVar("type") . " where id = $trackid");

                $idsDB = new idsDB;
                $idsQueryA = $idsDB->query("update idsMain set xcol1 = " . $objAction->getActionVar("type") . " where id = $trackid");

		$objAction->setActionVar("threshold_count", 0);
                $objAction->setActionVar("threshold_event_time", 0);
		$objAction->actionSave();
	}
}

function actionEmail($action, $trackid, $toEmail) {

        $idsDB = new idsDB;
        $idsQueryA = $idsDB->query("select sip, dip, sport, dport, etypeid, enameid, ename, level, sensorid, timestamp from idsTrack where id = $trackid");
        while (list($sip, $dip, $sport, $dport, $etypeid, $enameid, $ename, $level, $sensorid, $timestamp) = mysql_fetch_row($idsQueryA)) {

		$from_email = "OpenAanval@Aanval.com";
	        $from_name = "OpenAanval IDS Console";
	        $to_email = "$toEmail";
	        $to_name = "Alert Recipient";
	        $subject = "ALERT Action ($ename)";

	        $message = "The following alert was generated by the OpenAanval Intrusion Detection Console.\n---\n\n";
	        $message .= "Details:\n";
	        $message .= "Source IP: " . acid_to_ip($sip) . "\n";
	        $message .= "Destination IP: " . acid_to_ip($dip) . "\n";
	        $message .= "Sensor: $sensorid\n\n";

	        $message .= "Detected Event: $ename ($enameid)\n\n";
	        $message .= "http://www.snort.org/snort-db/sid.html?sid=$enameid\n\n";

        	$message .= "---\n";
	        $message .= "Action ID: $action\n";
	        $message .= "Event Timestamp: " . timeDisplay($timestamp, 1) . "\n";
	}

        sendmail($from_email, $from_name, $to_email, $to_name, $subject, $message);
}

function writeSemaphore($file) {

	$date = date("U");

	$fp = fopen ("$file", "w");
        if ($fp) {
        	fputs ($fp, "Aanval - Semaphore file: $date");
                fclose($fp);
        }
}

function execCommand($cmd) {

	$fp = popen($cmd, 'r');
	$read = fread($fp, 1024);
	pclose($fp);

}

function debugProcessor() {
        global $ops, $aanvaldbhost, $aanvaldbuser, $aanvaldbpass, $aanvaldb;

        $moduleDB = new moduleDB;
        $moduleDB->loadDB(1);
        $pquery = $moduleDB->query("select cid from event");
        while (list($d_cid) = mysql_fetch_row($pquery)) {

		$cid[] = $d_cid;

	}

        $idsDB = new idsDB;

	for ($i=0;$i<count($cid);$i++) {
		$tmp = "";
		$go = 0;

	        $idsQueryA = $idsDB->query("select id from idsMain where eid = $cid[$i]");
	        while ($row = mysql_fetch_row($idsQueryA)) {
			$tmp = $row[0];
	                $go = 1;
	        }

		if ($go == 0) echo "NUM: $tmp (EID: $cid[$i])\n";
	}
}

?>
