<?

// Register page speed processing variable
$start_time;

// Set Session Timeout to 4 Hours
ini_set("session.gc_maxlifetime","14400");

// Runtime operation checking & installation verification
@include "runtime.php";
runtime_approval($runtime);

// include configuration file for various basics
@include "conf.php";

// Load appropriate modules
recursiveModuleLoad();

# Session Initilization
$username = getVar("username");
$password = getVar("password");

$login = new mySession("openaanval");
$login->initSession($username, $password);
$login->loadSession();

# Variable Initilization
$ops = new myOps();
$ops->loadOps();

// Redirection Feature
$redir = getVar("redir");
$eredir = getVar("eredir");

if ($redir) {
	if ($rtime) {
		$rt = strip_tags(addslashes($rtime));
	} else {
		$rt = 2;
	}
        $location = "<meta HTTP-EQUIV='REFRESH' TARGET='_blank' CONTENT='$rt;URL=$redir'>";
        echo "$location";
}

if ($eredir) {
	$eredir = base64_decode($eredir);

        if ($rtime) {
                $rt = strip_tags(addslashes($rtime));
        } else {
                $rt = 2;
        }
        $location = "<meta HTTP-EQUIV='REFRESH' TARGET='_blank' CONTENT='$rt;URL=$eredir'>";
        echo "$location";
}

// Away we go - This is where we choose where we go
$op = getVar("op");
if (!$op) {
	if ($login->getSessionVar("login")) {
		$op = "pub_main";
	} else {
		$op = "pub_login";
	}
}

# OP Aliases
if ($op == "main") $op = "pub_main";

# REPORT Loading
if ($op == "pub_report_view") {
        $b = getVar("b");
	$type = getVar("type");
        if ($b == 1) {
                report_view();
        } else {
                $location = "<meta HTTP-EQUIV='REFRESH' TARGET='_blank' CONTENT='2;URL=?op=pub_report_view&b=1&type=$type'>";
                echo "$location";
		echo "<title>" . $ops->getOpsVar("site_reportTitleA") . "</title>";
                echo "<p>&nbsp;<p>&nbsp;<center><img border=0 src='" . $ops->getOpsVar("img_mascot_a") . "'><p><h2>
			" . $ops->getOpsVar("site_reportBuildTextA") . "<b></b></h2>
                        <img border=0 src='images/gears.gif'><p>(" . $ops->getOpsVar("site_reportBuildTextB") . ")</center>";
        }
        exit;
}

# Decides which OP parameters to allow and which to deny
$chunk = substr($op, 0, 4);
if ($chunk == "pub_") {
	dblog($op, "Public Ops Navigation", 0, "");
	site("$op");
} else if ($chunk == "prv_") {
	if ($login && $login->getSessionVar("login")) {
	        dblog($op, "Private Ops Navigation", 0, "");
		site("$op");
	} else {
		// unauthorized
	        dblog($op, "Private Ops Navigation", 0, "UNAUTHORIZED");
		site("pub_unauthorized");
	}
} else {
	// unauthorized
        dblog($op, "UNKNOWN Ops Navigation", 0, "UNAUTHORIZED");
        site("pub_unauthorized");
}

function recursiveModuleLoad() {
	global $root_path;

	# Read in all available modules recursively
	if (!$this_dir = @dir("$root_path/modules/")) {
	        echo "conf.php ERROR:<p>\$root_path not correct or $root_path/modules/ not found! Check your conf.php settings<p>Exiting.";
	        exit;
	}
	while ($dir = $this_dir->read()) {
	        if ($dir != "." && $dir != "..") {
	                if (substr($dir, -4, 4) == "_MOD") {
	                        $this_sub = dir("$root_path/modules/$dir");
	                        while ($file = $this_sub->read()) {
	                                if ($file != "." && $file != "..") {
	                                        if (substr($file, 0,4) == "inc_") {
	                                                include "./modules/$dir/$file";
	                                        }
	                                }
	                        }
	                }
	        }
	}
}

?>
